 ---------------------------------------------------------------------------
-- Useful library functions for SPLIT.EX                                   --
 ------------------------------------. ,------------------------------------
 ------------------------------------' `------------------------------------
-- Mathematics and String Handling                                         --
 ---------------------------------------------------------------------------
global function tolower(object x)
    return x+(x>='A'and x<='Z')*32--('a'-'A')
end function

global function toupper(object x)
    return x-(x>='a'and x<='z')*32--('a'-'A')
end function

global function ciequal(sequence a, sequence b)
    -- Case insensitive equal()
    return (compare(tolower(a), tolower(b)) = 0)
end function

global function ceil(object x)
    return -floor(-x)
end function

-- global function ceil(object x)
--     return floor(x+.5)
-- end function

constant
    Digit = "0123456789ABCDEF"

global function seq2int(sequence seq)
    -- Returns a *positive* integer (except for '%'!)
    -- If number is prefixed by $, # or H or suffixed by H, it is taken to
    -- be a hexadecimal number.
    -- If prefixed or suffixed by % then a negative number is returned.
    -- Percentages only work in base 10.

    integer out, base, multiplier
    integer digitp1

    seq        = toupper(seq)
    base       = 10
    multiplier = 1
    digitp1    = 0

    if length(seq) = 0 then
	return 0
    end if

    if find(seq[1], "$#H") then
	base = 16
	seq  = seq[2..length(seq)]
    elsif seq[length(seq)] = 'H' then
	base = 16
	seq = seq[1..length(seq-1)]
    end if

    if base = 10 then
	if seq[length(seq)] = 'B' then
	    multiplier = 1
	    seq = seq[1..length(seq)-1]
	end if
	if seq[length(seq)] = 'K' then
	    multiplier = 1024
	    seq = seq[1..length(seq)-1]
	elsif seq[length(seq)] = 'M' then
	    multiplier = 1048576
	    seq = seq[1..length(seq)-1]
	end if
    end if

    out = 0
    for i = 1 to length(seq) do
	digitp1 = find(seq[i], Digit[1..base])
	if digitp1 then
	    out = base * out + digitp1 - 1
	else
	    exit--at invalid char.
	end if
    end for

    return out * multiplier
end function

global function ordinal(integer num)
    sequence suffix
    integer lastdigit, lastbutone
    lastdigit = remainder(num,10)
    lastbutone = remainder(floor(num/10),10)

    suffix = "th"
    if lastbutone != 1 then
	if lastdigit = 1 then
	    suffix = "st"
	elsif lastdigit = 2 then
	    suffix = "nd"
	elsif lastdigit = 3 then
	    suffix = "rd"
	end if
    end if

    return sprintf("%d",num) & suffix
end function

 ---------------------------------------------------------------------------
-- [Windows 95] File Handling                                              --
 ---------------------------------------------------------------------------
global function exist(sequence filename)
    integer status

    --system("cd " & current_dir(), 2)
    -- open() works on Win95 filenames!
    status = open(filename, "rb")
    if status != -1 then
	close(status)
	return 1
    end if

    return 0
end function

global constant inLinux = (platform() = LINUX)

integer temp
temp = '\\'
if inLinux then
    temp = '/'
end if

global constant Slash = temp

global function is_long_filename(sequence filename)
    integer dotpos

    if inLinux then
	return 1
    end if

    dotpos = find('.',filename)
    if dotpos then
	filename[dotpos] = -'.' -- Hide the first dot
    end if

    if find('.',filename) or find(' ', filename) or
    (dotpos = 0 and length(filename) > 8) or
    (dotpos > 0 and length(filename)-dotpos > 3)then
	return 1
    else
	return 0
    end if

end function

global function lfndir(sequence pattern)
    if inLinux then
	return dir(pattern)
    end if
    return Dir95(pattern)
end function

global function lfnopen(sequence filename, sequence mode)
    integer handle
    if not length(mode) or not length(filename) then
	return -1
    end if

    if mode[1] != 'r' then
	if not exist(filename) then
	    if is_long_filename(filename) then
		if inLinux then
		    system("touch \"" & filename & "\"", 2)
		else
		    system("rem > \"" & filename & "\"", 2)
		end if
	    else
		system("rem > " & filename, 2)
	    end if
	end if
    end if

    handle = open(filename, mode)
    return handle
end function

