constant TITLE =
"Split 2000 - File Splitter - (c)2000 CyrekSoft\n"

-- This code is *really* self-explanitory. (IM[OSH]O)
    include get.e      -- wait_key()
include speaker.e  -- musical!
include diskutil.e -- check_drive(), current_drive()
include dir95.e    -- allow_break(), current_dir(), dir(), Dir95()
include split.e    -- Everything in it. Just a few things I decided to shift
		   -- out of this main file :)
without warning
allow_break(0)

constant
    FloppySize = seq2int("1423k"),
	-- Strictly speaking, it should be 1423.5*1024, but 1423k leaves
	-- room for one bad sector.
    MaxBufferSize = FloppySize -- optimise for floppysplit

-- Basic user communication routines

global sequence cmdline
cmdline = command_line()
cmdline = cmdline[3..length(cmdline)]
cmdline = cmdline & repeat("",64-length(cmdline))

procedure usage()
    sequence fromfloppy, ontofloppy, floppyonly, driveinfo, nameinfo
    if inLinux then
	fromfloppy = ""
	ontofloppy = ""
	floppyonly = ""
	driveinfo  = ""
	nameinfo   = "standard Linux"
    else
	fromfloppy = " [from floppy [Drive]]"
	ontofloppy = " [onto floppy [Drive]]"
	floppyonly = "  split Filename onto floppy [Drive]\n"
	driveinfo  = "\"Drive\"s are of form a|b[:]\n"
	nameinfo   = "either MS-DOS 8.3 filenames or Long"
    end if
    puts(1,
	"Usages:\n"&
	"  split help\n"&
	"  split remake all" & fromfloppy & "\n" &
	"  split remake FileName" & fromfloppy & "\n" &
	"  split Filename into Number pieces" & ontofloppy & "\n" &
	"  split Filename into Number chunks" & ontofloppy & "\n" &
	"  split Filename with ratio Number:Number[:Number...]" & ontofloppy & "\n" &
	"  split Filename with sizes [Number|rest]..." & ontofloppy & "\n" &
	floppyonly &
	    "\n"&
	driveinfo &
	"\"FileName\"s are " & nameinfo & " filenames\n"&
	"\"Number\"s are either in hexadecimal or decimal:\n"&
	"  Hex: [$|#|H]{0-9 A-F...}[H]\n"&
	"  Dec: {0-9...}[B|K[B]|M[B]]\n"&
	    "\n"&
	"See documentation for more info...\n"&
    {})
    abort(1)
end procedure

-- Sounds
constant Short=8, SoundOff = match("nosound",tolower(getenv("SPLIT"))&"")

procedure bad_sound()
    if SoundOff then return end if
    endnote(8, Short*2)
    endnote(8, Short*2)
    endnote(8, Short*2)
    endnote(4, Short*6)
end procedure

procedure good_sound()
    if SoundOff then return end if
    endnote(29, Short)
     dsound( 0, Short)
    endnote(25, Short*2)
end procedure

-- Back to user communication
procedure null_key(integer attention)
    integer k
    if attention then
	good_sound()
    end if
    k = wait_key()
    if k = 3 or k = 27 then
	puts(1, "User cancelled the operation.")
	abort(255)
    end if
end procedure

integer had_warning_previously had_warning_previously = 0
procedure warn(sequence message)
    if not had_warning_previously then
	had_warning_previously = 1
	puts(2, "\n")
    end if
    puts(2, "  Warning: " & message & ".\n")
    puts(2, "           Press [Enter] to continue, [Esc] to cancel.\n\n")
    null_key(1)
end procedure

procedure error(sequence message)
    bad_sound()
    if not had_warning_previously then
	puts(2, "\n")
    end if
    puts(2, "  " & message & ".\n\n")
    puts(2, "Type 'split help' for more info...\n")
    abort(2)
end procedure

-- Filename manipulations

function namesplit(sequence filename)
    sequence name, extension
    integer dotpos

    dotpos = find('.', filename)

    if not dotpos or is_long_filename(filename) then
	return {filename, ""}
    end if

    -- Must be short filename in DOS

    name = filename[1..dotpos-1]
    extension = filename[dotpos..length(filename)]

    return {name, extension}
end function

function make_extension(integer ord)
    ord = ord - 1
    return ".x"
	    & (floor(ord / 26) + 'a')
	    & (remainder(ord, 26) + 'a')
end function

function unmake_extension(sequence extension)
    integer l
    l = length(extension)
    extension = tolower(extension[l-1..l])-'a'
    return extension[1] * 26 + extension[2] + 1
end function

-- Floppy disk handling routines

function get_floppy_letter(sequence drive)
    integer letter
    letter = 0
    if not ciequal(drive, "")then
	if length(drive) > 2 then
	    error("Invalid floppy specification")
	elsif length(drive) = 2 then
	    if drive[2] != ':' then
		error("Only ':' is valid after a floppy drive letter")
	    end if
	end if

	letter = tolower(drive[1])

	if not find(letter,"ab") then
	    error("Invalid floppy drive letter")
	end if
    end if
    return letter
end function

constant Still="still "

function check_for_floppy(object prompt, integer drv, sequence fn)
    -- Used by Unsplit()

    object files
    sequence xxx, stillnodisk
    integer status

    if sequence(prompt) then
	xxx = ".x??"
	prompt = prompt & " floppy"
    else
	xxx = make_extension(prompt)
	prompt = ordinal(prompt) & " floppy"
    end if

    prompt = "\n  Place "& prompt &" of set in drive " & drv & ": and press a key..."

    puts(1, prompt & "\n")
    null_key(1)

    files = 0
    status = check_drive(drv)
    stillnodisk = ""

    while 1 do -- exit condition is midloop
	if status = DRIVE_READY or status = DRIVE_WRITE_PROTECTED then
	    -- It doesn't really matter if the disk is w/p. We can still
	    -- read from it.
	    files = lfndir(drv & ":\\" & fn & xxx)
	elsif status = DRIVE_NOT_READY then
	    puts(1, "  There is "&stillnodisk&"no disk in drive "&drv&":. Please insert one.\n")
	    stillnodisk = Still
	elsif status = DRIVE_NOT_EXIST then
	    if drv = 'b' then
		error("The b: drive does not exist")
	    else
		error("This computer has no floppy drives")
	    end if
	end if

	if sequence(files) then
	    exit
	end if

	puts(1, prompt & " [Esc] quits.\n")
	null_key(0)
	status = check_drive(drv)
    end while

    return unmake_extension(files[1][D_LONGNAME])
end function

procedure check_for_empty_floppy(integer p,integer drv)
    -- Used by Split()

    object prompt, files
    sequence stillwp, stillfull, stillnodisk
    integer status

    prompt = ordinal(p) & " floppy"

    prompt = "\n  Place "& prompt &" of set in drive " & drv & ": and press a key..."

    puts(1, prompt & "\n")
    null_key(1)

    files = 0
    status = check_drive(drv)
    stillwp = ""
    stillfull = ""
    stillnodisk = ""

    while 2 do --exit is midloop
	if status = DRIVE_READY or status = DRIVE_WRITE_PROTECTED then
	    files = dir(drv & ":\\")
	    -- for some reason Dir95 doesn't work here
	elsif status = DRIVE_NOT_EXIST then
	    if drv = 'b' then
		error("The b: drive does not exist")
	    else
		error("This computer has no floppy drives")
	    end if
	end if

	if integer(files) then
	    -- Completely empty floppies don't even have . and .. entries
	    -- and so dir() should return -1 to an empty disk
	    if status = DRIVE_READY then
		exit
	    elsif status = DRIVE_NOT_READY then
		puts(1, "  There is "&stillnodisk&"no disk in drive "&drv&":. Please insert one.\n")
		stillnodisk = Still
	    else--Write_Protected!
		puts(1, "  This disk is valid but is "&stillwp&"write-protected. Please unprotect it.\n")
		stillwp = Still
	    end if
	else
	    puts(1, "  This disk "&stillfull&"appears to have files on it. Please insert a fresh disk.\n")
	    stillfull = Still
	end if

	puts(1, prompt & " [Esc] quits.\n")
	null_key(0)
	status = check_drive(drv)
    end while

end procedure

-- Main unsplit (remake) routine

procedure unsplit()
    sequence all_names, filename, ext, xxx
    integer floppy, pos

    integer chunknum, lastchunknum

    sequence Buffer
    integer infile, outfile
    integer c

    -- ** Command line error checking **

    pos = 2

    if ciequal(cmdline[2], "") then
	error("Expected 'all' or splitfile filename to remake")
    end if

    floppy = 0
    filename = cmdline[2]

    if find(Slash, filename) or (not inLinux and filename[2] = ':') then
	error("Split only works in current directory")
    end if

    if not inLinux and ciequal(cmdline[3], "from") then
	if ciequal(cmdline[4], "floppy") then
	    floppy = get_floppy_letter(cmdline[5])
	    pos = 5
	    if not floppy then
		pos = 4
		floppy = 'a'
	    end if
	else
	    error("'floppy' expected after 'from'")
	end if
    end if

    if ciequal(filename, "all") then
	all_names = {} & lfndir("*" & make_extension(1))
	if 0=compare(all_names, {-1}) then
	    error("Can't find an 'xaa' file chunk.")
	end if
	for i = 1 to length(all_names) do
	    if inLinux then
		filename = all_names[i][D_NAME]
	    else
		filename = all_names[i][D_LONGNAME]
	    end if
	    -- Chop off .x?? extension
	    filename = filename[1..length(filename)-4]

	    if not is_long_filename(filename) then
		warn(
		    filename &
		    ": The original extension is not known and will be lost"
		)
	    end if

	    all_names[i] = filename
	end for
    else
	all_names = {filename}
    end if

    if not ciequal(cmdline[pos+1], "") then
	error("Unexpected data found after command")
    end if

    -- ** Initialisation and further error checking **

    for i = 1 to length(all_names) do

	filename = namesplit(all_names[i])
	ext = filename[2]
	filename = filename[1]

	chunknum = 1

	if floppy then

	    lastchunknum = check_for_floppy("last",  floppy, filename)
	    --chunknum   = check_for_floppy("first", floppy, filename)

	else
	    lastchunknum = 0

	    xxx = make_extension(chunknum)
	    if not exist(filename & xxx) then
		error("Can't find " & filename & xxx)
	    end if
	end if

	xxx = make_extension(chunknum)

	Buffer = {}

	puts(1, "  Remaking "& filename & ext &"...\n")

	outfile = lfnopen(filename & ext, "wb")
	if outfile = -1 then
	    error("Unable to remake file")
	end if

	while
		(floppy and chunknum <= lastchunknum)
	    or
		(not floppy and exist(filename & xxx))
	    do

	    if floppy then
		if check_for_floppy(chunknum, floppy, filename) then
		end if

		infile = lfnopen(floppy & ":\\" & filename & xxx, "rb")
		if infile = -1 then
		    error("Floppy error. Disk may have been changed/removed.")
		end if
	    else
		infile = lfnopen(filename & xxx, "rb")
		if infile = -1 then
		    error("File ceased to exist on hard disk")
		end if
	    end if

	    puts(1, "  Splicing "& filename & xxx &"...\n")

	-- ** Main code block **

	    while 1 do
		-- After all that error checking, this is the bit that
		-- actually does something useful!
		c = getc(infile)

		if c < 0 then -- Check for EOF
		    exit
		end if

		Buffer = Buffer & c

		if length(Buffer) >= MaxBufferSize then
		    puts(outfile, Buffer)
		    Buffer = {}
		end if

	    end while

	    close(infile)

	    chunknum = chunknum + 1
	    xxx = make_extension(chunknum)

	end while

	if length(Buffer) then -- Write out "dregs" :)
	    puts(outfile, Buffer)
	end if

	close(outfile)

    end for -- all_names loop

end procedure

-- Pre-split in-'split()' calculations

function sum(sequence x)
    integer t
    t = 0
    for i = 1 to length(x) do
	t = t + x[i]
    end for
    return t
end function

function split_into_calcsizes(integer filesize, integer number)
    sequence sizes
    integer size

    sizes = {}
    size = ceil(filesize / number)

    if size > 676 then--unmake_extension(".xzz") then
	error("Too many files will be created with these parameters")
    end if


    sizes = repeat(number, size)
    sizes[length(sizes)] =
	sizes[length(sizes)] - (size * number - filesize)

    return sizes
end function


function split_into(integer filesize)
    integer number

    number = seq2int(cmdline[3])

    if ciequal(cmdline[4], "pieces") then
	number = ceil(filesize / number)
    elsif not ciequal(cmdline[4], "chunks") then
	error("Expected either 'pieces' or 'chunks'")
    end if

    return {split_into_calcsizes(filesize, number), 4}
end function

constant Rest = 1

function split_with(integer filesize)
    sequence sizes, ratio
    integer number, pos, ratiostart, ratiopos, restpos, sumsizes

    pos = 3

    ratio = ""
    sizes = {}
    ratiostart = 1
    number = 0

    if ciequal(cmdline[pos], "ratio") then
	pos = pos + 1
	ratio = cmdline[pos]

	if not length(ratio) then
	    error("Expected numeric ratio after 'ratio'")
	end if

	ratiopos = find(':', ratio)

	if not ratiopos then
	    error("'ratio' lists must not contain spaces and must be in at least two parts")
	elsif ratiopos = 1 then
	    error("'ratio' lists may not begin with ':'")
	elsif ratio[length(ratio)] = ':' then
	    error("'ratio' lists may not end with ':'")
	end if

	-- Add a colon for simplicity
	ratio = ratio & ':'

	while 1 do
	    sizes = sizes & seq2int(ratio[ratiostart..ratiopos-1])
	    ratiostart = ratiopos + 1

	if ratiostart >= length(ratio) then
	    exit
	end if

	    ratio[ratiopos] = '-'
	    if ratio[ratiostart] = ':' then
		error("Double colon found in 'ratio' list")
	    end if
	    ratiopos = find(':', ratio)
	end while

	sumsizes = sum(sizes)           --> 1:2:1:4    --> 8
	sizes = sizes * filesize        --> f:2f:1f:4f
	sizes = ceil(sizes/sumsizes)    --> f/8+e:f/4+e:f/8+e:f/2+e

	sizes[length(sizes)] =          --> f/8+e:f/4+e:f/8+e:f/2-3e --> f
	    sizes[length(sizes)] - (sum(sizes)-filesize)

    elsif ciequal(cmdline[pos], "sizes") then

	pos = pos + 1
	number = seq2int(cmdline[pos])
	if not number and ciequal(cmdline[pos], "rest") then
	    number = Rest
	end if

	if number = 0 then
	    error("At least one number must be given for a 'sizes' list")
	end if

	while number != 0 do
	    sizes = sizes & number
	    pos = pos + 1

	    number = seq2int(cmdline[pos])
	    if not number and ciequal(cmdline[pos], "rest") then
		if find(Rest, sizes) then
		    error("'rest' may only be used once in a 'sizes' list")
		end if
		number = Rest
	    end if
	end while

	if not find(cmdline[pos], {"onto", ""}) then
	    error("Expected 'rest' or 'onto floppy'")
	end if

	-- deal with 'rest' parameter
	restpos = find(Rest, sizes)
	if restpos then
	    sizes[restpos] = filesize - (sum(sizes) - Rest)
	end if

	pos = pos - 1 -- the 'while' loop reads past the last element

    else
	error("Expected either 'ratio' or 'sizes'")
    end if

    return {sizes, pos}
end function

-- Main split routine:

procedure split()
    object temp

    sequence filename, extension, xxx

    sequence chunklengths
    integer chunknum, cklenpos, chunkpos
    integer filesize, filepos

    integer floppy, pos

    sequence Buffer
    integer infile, outfile

    if ciequal(cmdline[1], "") then
	error("Expected name of file to split")
    end if

    filename = cmdline[1]

    if find(Slash, filename) or (not inLinux and filename[2] = ':') then
	error("Split only works in current directory")
    end if

    if not exist(filename) then
	error("Can't find file to split")
    end if

    temp = lfndir(filename)
    filesize = temp[1][D_SIZE]

    if ciequal(cmdline[2], "into") then
	temp = split_into(filesize)
    elsif ciequal(cmdline[2], "with") then
	temp = split_with(filesize)
    elsif not inLinux and ciequal(cmdline[2], "onto") then
	temp = {split_into_calcsizes(filesize, FloppySize),1}
    else
	if inLinux then
	    error("Expected 'into' or 'with'")
	else
	    error("Expected 'into', 'with' or 'onto'")
	end if
    end if

    chunklengths = temp[1]
	     pos = temp[2]

    floppy = 0
    if not inLinux and ciequal(cmdline[pos+1], "onto") then
	if ciequal(cmdline[pos+2], "floppy") then
	    pos = pos + 3
	    floppy = get_floppy_letter(cmdline[pos])
	    if not floppy then
		floppy = 'a'
		pos = pos - 1
	    end if
	else
	    error("'floppy' expected after 'onto'")
	end if
    end if

    if floppy and find(1, (chunklengths > FloppySize)) then
	error("At least one of the parameters will overload a floppy")
    end if

    if not ciequal(cmdline[pos+1], "") then
	error("Unexpected data found after command")
    end if

    -- User warnings...

    if not floppy and length(chunklengths) >= 25 then
	warn(
	    "This will generate " &
	    sprintf("%d",length(chunklengths)) &
	    " file pieces"
	)
    elsif floppy and length(chunklengths) >= 10 then
	warn(
	    "This will require " &
	    sprintf("%d", length(chunklengths)) &
	    " floppy disks"
	)
    elsif floppy and chunklengths[1] < seq2int("355k") then
	warn(
	    "At least one file piece may waste a large\n" &
	    "amount of space on a floppy disk"
	)
    end if

    if find(1,(chunklengths<256)) then
	warn("At least one filechunk will be smaller than 256 bytes")
    end if

    -- Start splitting

    filename = namesplit(filename)
    extension = filename[2]
    filename = filename[1]

    -- ** Main code block **

    Buffer = {}

    puts(1, "  Splitting "& filename & extension &"...\n")

    infile = lfnopen(filename & extension, "rb")
    if infile = -1 then
	error("File ceased to exist on hard disk")
    end if

    chunknum = 1
    cklenpos = 1 -- always = remainder(chunknum-1, length(chunklengths))+1
    filepos  = 1

    while filepos < filesize do

	xxx = make_extension(chunknum)

	if floppy then
	    check_for_empty_floppy(chunknum, floppy)

	    outfile = lfnopen(floppy & ":\\" & filename & xxx, "wb")
	    if outfile = -1 then
		error("Floppy error. Disk is write-protected or damaged")
	    end if
	else
	    outfile = lfnopen(filename & xxx, "wb")
	    if outfile = -1 then
		error("Can't create filechunk on hard disk")
	    end if
	end if

	puts(1, "  Creating  "& filename & xxx &"...\n")

	chunkpos = 1

	while
	    chunkpos <= chunklengths[cklenpos]
	and
	    filepos <= filesize
	do

	    Buffer = Buffer &
		getc(infile)

	    if length(Buffer) >= MaxBufferSize then
		puts(outfile, Buffer)
		Buffer = {}
	    end if

	    chunkpos = chunkpos + 1
	    filepos = filepos + 1

	end while

	if length(Buffer) then -- Write out "dregs" :)
	    puts(outfile, Buffer)
	    Buffer = {}
	    -- Normally Buffer wouldn't be cleared here, but Buffer
	    -- could only possibly contain the end of the chunk and
	    -- no more (in this case).
	end if

	close(outfile)

	chunknum = chunknum + 1
	cklenpos = cklenpos + 1
	if cklenpos > length(chunklengths) then
	    cklenpos = 1
	end if

    end while

    close(infile)

    -- ** Create reconstructor batch/shellscript **

    if inLinux then
	puts(1, "  Creating  "& filename & ".sh...\n")

	outfile = lfnopen(filename & ".sh", "w")
	if outfile = -1 then
	    error("Can't create shellscript")
	end if

	puts(outfile, "split remake "& filename & extension)
	puts(outfile, " $1 $2 $3\n")

	close(outfile)

	system("chmod 700 " & filename & ".sh",2)

    else
	puts(1, "  Creating  "& filename & ".bat...\n")

	if floppy then
	    outfile = lfnopen(floppy & ":\\" & filename & ".bat", "w")
	else
	    outfile = lfnopen(filename & ".bat", "w")
	end if
	if outfile = -1 then
	    error("Can't create batchfile")
	end if

	puts(outfile, "@split remake "& filename & extension)
	if floppy then
	    puts(outfile, " from floppy")
	end if
	puts(outfile, " %1 %2 %3\n")

	close(outfile)

    end if

end procedure

-- The Fuse

procedure main()
    puts(1, TITLE)
    if not inLinux and tolower(current_drive()) <= 'b' then
	error(
	    "Cannot run from floppy drive. Harddisk only.\n"&
	    "  If you received this message by running a batchfile from disk, move/copy\n"&
	    "  the batchfile into the directory you want the file to be remade and run\n"&
	    "  it again"&
	{})
    end if
    if ciequal(cmdline[1], "") then
	error("Expected to find 'help', 'remake' or a filename")
    elsif ciequal(cmdline[1], "help") then
	usage()
    elsif ciequal(tolower(cmdline[1]), "remake") then
	unsplit()
    else
	split()
    end if
    puts(1,"Done.")
end procedure

-- Go go go!

main()
abort(0)

 ---------------------------------------------------------------------------
-- End of program                                                          --
 ---------------------------------------------------------------------------

